# core.sync.semaphore

The semaphore module provides a general use semaphore for synchronization.
License:
Boost License 1.0
Authors:
Sean Kelly
Source:

class Semaphore;
  This class represents a general counting semaphore as concieved by Edsger Dijkstra. As per Mesa type monitors however, "signal" has been replaced with "notify" to indicate that control is not transferred to the waiter when a notification is sent.
  this(uint count = 0);
    Initializes a semaphore object with the specified initial count.
    Params:

    uint count | The initial count for the semaphore.

    Throws:
    SyncException on error.
  void wait();
    Wait until the current count is above zero, then atomically decrement the count by one and return.
    Throws:
    SyncException on error.
  bool wait(Duration val);
    Suspends the calling thread until the current count moves above zero or until the supplied time period has elapsed. If the count moves above zero in this interval, then atomically decrement the count by one and return true. Otherwise, return false.
    Params:

    period | The time to wait.

    In:
    val must be non-negative.
    Throws:
    SyncException on error.
    Returns:
    true if notified before the timeout and false if not.
  deprecated bool wait(long period);
    Deprecated. It will be removed in December 2012. Please use the version which takes a instead.
    Suspends the calling thread until the current count moves above zero or until the supplied time period has elapsed. If the count moves above zero in this interval, then atomically decrement the count by one and return true. Otherwise, return false.
    Params:

    long period | The time to wait, in 100 nanosecond intervals. This value may be adjusted to equal to the maximum wait period supported by the target platform if it is too large.

    In:
    period must be non-negative.
    Throws:
    SyncException on error.
    Returns:
    true if notified before the timeout and false if not.
  void notify();
    Atomically increment the current count by one. This will notify one waiter, if there are any in the queue.
    Throws:
    SyncException on error.
  bool tryWait();
    If the current count is equal to zero, return. Otherwise, atomically decrement the count by one and return true.
    Throws:
    SyncException on error.
    Returns:
    true if the count was above zero and false if not.

Page generated by Ddoc. Copyright Sean Kelly 2005 - 2009.